System.register(["@angular/core", "./core"], function (exports_1, context_1) {
    "use strict";
    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = (this && this.__metadata) || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var __moduleName = context_1 && context_1.id;
    var core_1, core_2, EJTemplateDirective;
    return {
        setters: [
            function (core_1_1) {
                core_1 = core_1_1;
                exports_1({
                    "ContentChild": core_1_1["ContentChild"],
                    "Type": core_1_1["Type"],
                    "forwardRef": core_1_1["forwardRef"]
                });
            },
            function (core_2_1) {
                core_2 = core_2_1;
            }
        ],
        execute: function () {
            EJTemplateDirective = (function () {
                function EJTemplateDirective(el, viewContainerRef, templateRef) {
                    this.el = el;
                    this.viewContainerRef = viewContainerRef;
                    this.templateRef = templateRef;
                    this.childViews = [];
                    this.element = core_2.currentTemplateElement;
                }
                EJTemplateDirective.prototype.ngOnInit = function () {
                    var template = this.viewContainerRef.createEmbeddedView(this.templateRef, { '$implicit': [] });
                    var templID = ej.getGuid('angulartmplstr');
                    var tempEle = ej.buildTag('div#' + templID);
                    $(tempEle).append(template.rootNodes);
                    ej.createObject('template', $($(tempEle).append(template.rootNodes)).html(), this.element);
                    this.element.template = $($(tempEle).append(template.rootNodes)).html();
                    ej.createObject('_templateRef', this.templateRef, this.element);
                    ej.createObject('_viewRef', this.viewContainerRef, this.element);
                    $(tempEle).remove();
                };
                EJTemplateDirective.prototype.ngAfterViewInit = function () {
                    var _this = this;
                    window.setTimeout(function () {
                        _this.compileTempalte();
                        var parentWidget = _this.element.parent.widget || _this.element.widget;
                        parentWidget.element.on(parentWidget.pluginName + 'refresh', function () {
                            if (parentWidget.angularTemplate) {
                                _this.compileTempalte();
                            }
                        });
                    });
                };
                EJTemplateDirective.prototype.compileTempalte = function () {
                    var widget = this.element.parent.widget || this.element.widget;
                    var element = widget.element;
                    var childView;
                    var templates = $(element).find('.ej-angular-template');
                    var templateObject = widget.angularTemplate;
                    for (var template in templateObject) {
                        var tmplElement = templates.filter('.' + templateObject[template].key);
                        if (tmplElement.length) {
                            for (var i = 0; i < tmplElement.length; i++) {
                                var index = parseInt($(tmplElement[i]).attr('ej-prop'));
                                childView = templateObject[template].viewRef[index].createEmbeddedView(templateObject[template].templateRef[index], { '$implicit': templateObject[template].itemData[index] });
                                //childView = (<ViewContainerRef>templateObject[template].viewRef[i]).createEmbeddedView(<TemplateRef<any>>templateObject[template].templateRef[i], { '$implicit': templateObject[template].itemData[parseInt($(tmplElement[i]).attr('ej-prop'))] });
                                $(tmplElement[i]).empty().append(childView.rootNodes);
                            }
                        }
                        else {
                            delete templateObject[template];
                        }
                    }
                };
                EJTemplateDirective.prototype.clearTempalte = function () {
                    var templateObject = this.element.parent.widget.angularTemplate;
                    if (templateObject && Object.keys(templateObject).length) {
                        for (var tmpl in templateObject) {
                            delete templateObject[tmpl];
                        }
                    }
                    for (var childView in this.childViews) {
                        delete this.childViews[childView];
                    }
                    this.viewContainerRef.remove();
                };
                EJTemplateDirective.prototype.ngOnDestroy = function () {
                    this.clearTempalte();
                };
                EJTemplateDirective = __decorate([
                    core_1.Directive({
                        selector: "[e-template]"
                    }),
                    __metadata("design:paramtypes", [core_1.ElementRef, core_1.ViewContainerRef,
                        core_1.TemplateRef])
                ], EJTemplateDirective);
                return EJTemplateDirective;
            }());
            exports_1("EJTemplateDirective", EJTemplateDirective);
            ej.template['text/x-template'] = function (self, selector, data, index, prop) {
                var templateObject = self.angularTemplate;
                if (!templateObject || !templateObject[selector]) {
                    templateObject = templateObject || {};
                    templateObject[selector] = { key: ej.getGuid('angulartmpl'), itemData: [], viewRef: [], templateRef: [] };
                    self.angularTemplate = templateObject;
                }
                var scope = templateObject[selector];
                if (!ej.isNullOrUndefined(index)) {
                    if (!scope.itemData) {
                        scope.itemData = [];
                    }
                    scope.itemData[index] = data;
                    scope.viewRef[index] = prop._viewRef;
                    scope.templateRef[index] = prop._templateRef;
                }
                else {
                    scope.itemData = [data];
                    scope.viewRef = [prop._viewRef];
                    scope.templateRef = [prop._templateRef];
                }
                // let actElement = $(selector).html() || '';
                var actElement = '';
                if (selector.startsWith('#'))
                    actElement = $(selector).html() || '';
                else
                    actElement = selector;
                var tempElement = '<div ej-prop=\'' + index + '\' class=\'' + templateObject[selector].key + ' ej-angular-template\'>' + actElement + '</div>';
                return tempElement;
            };
            ej.template.render = ej.template['text/x-template'];
        }
    };
});
//# sourceMappingURL=template.js.map